export declare class CacheMoudle<T> {
    private static handle;
    static init(): Promise<void>;
    /**
     * 创建cache
     * @param name 模块名字 如果没有名字将不支持自动update功能
     * @param ttl 数据有效期
     */
    static createCache<T>(name: string, ttl?: number): CacheMoudle<T>;
    static removeCache(name: string): void;
    static update(): Promise<void>;
    static cacheMap: {
        [key: string]: CacheMoudle<any>;
    };
    valueCache: {
        [roleId: string]: {
            time: number;
            value: T;
        };
    };
    ttl: number;
    private constructor();
    set(key: string, value: T): void;
    hasOwnProperty(key: string): boolean;
    get(key: string): T | undefined;
    del(key: string): void;
    forEach(cb: (value: T, key: string) => boolean | void): void;
    private _update;
}
