/// <reference types="node" />
import { EventEmitter } from 'events';
export declare class ResourceModule<T> extends EventEmitter {
    static cache: {
        [key: string]: ResourceModule<any>;
    };
    static watch<T>(file: string): ResourceModule<T>;
    resData: {
        [tkey: string]: T;
    };
    private file;
    md5: string;
    private constructor();
    private init;
    private _onFileChange;
    private _loadFile;
    getAllRes(): {
        [tkey: string]: T;
    };
    getRes(id: string): T | undefined;
    has(id: string): boolean;
    /**
     * 遍历
     * @param func 返回 true的时候跳出循环
     */
    forEach(func: (value: T, key: string, res: this) => boolean | void): void;
}
