"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = require("path");
const crypto_1 = require("crypto");
const events_1 = require("events");
class ResourceModule extends events_1.EventEmitter {
    constructor(file) {
        super();
        //-----------------------------------------------//
        this.resData = {};
        this.file = '';
        this.md5 = '';
        this.file = path_1.join(process.cwd(), file);
    }
    static watch(file) {
        if (this.cache.hasOwnProperty(file))
            return this.cache[file];
        this.cache[file] = new ResourceModule(file);
        this.cache[file].init();
        return this.cache[file];
    }
    init() {
        fs_1.default.watchFile(this.file, this._onFileChange.bind(this));
        this._loadFile();
        process.nextTick(() => {
            this.emit("change");
        });
    }
    _onFileChange(curr, prev) {
        if (prev.ctime.getTime() == 0) {
            //console.log('文件被创建!');
            this._loadFile();
            this.emit('change');
        }
        else if (curr.ctime.getTime() == 0) {
            // console.log('文件被删除!')
            this.resData = {};
            this.emit('change');
        }
        else if (curr.mtime.getTime() != prev.mtime.getTime()) {
            // console.log('文件有修改');
            this._loadFile();
            this.emit('change');
        }
    }
    _loadFile() {
        this.resData = {};
        try {
            let fileInfo = fs_1.default.readFileSync(this.file).toString();
            this.md5 = crypto_1.createHash('md5').update(fileInfo).digest('hex');
            let allData = JSON.parse(fileInfo);
            for (let key in allData) {
                if (!allData.hasOwnProperty(key) || key == 'Template') {
                    continue;
                }
                this.resData['k' + key] = allData[key];
            }
        }
        catch (e) {
            console.error('res error:' + this.file);
        }
    }
    getAllRes() {
        return this.resData;
    }
    ;
    getRes(id) {
        id = 'k' + id;
        if (this.resData.hasOwnProperty(id)) {
            return this.resData[id];
        }
        return undefined;
    }
    ;
    has(id) {
        id = 'k' + id;
        if (this.resData.hasOwnProperty(id)) {
            return true;
        }
        return false;
    }
    /**
     * 遍历
     * @param func 返回 true的时候跳出循环
     */
    forEach(func) {
        for (let key in this.resData) {
            if (func(this.resData[key], key.slice(1, key.length), this)) {
                break;
            }
        }
    }
}
exports.ResourceModule = ResourceModule;
ResourceModule.cache = {};
